#<profile4xi profile = "02" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "maybeencodingerror4xi.py">
#<abstract4xi abstract = "provides class MaybeEncodingError4Xi"/>
#<refer4xi reference = "pool.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'MaybeEncodingError4Xi' ]  
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
try:                 # system ones
    import os
    import sys
    import signal
except:
    pass
try:                 # threading ones       
    import threading                
    import _thread   
except:
    pass
try:
    import _winapi
except:
    pass

                
try:                 # most-common ones
    import time         
except:
    pass
try:                 # rare ones
    import collections     
    import itertools
    import queue            
except:
    pass 
try:                 # imported-as ones 
    pass          
except:
    pass            
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
try:                             # Binary ones
    import _multiprocessing
except:
    pass
try:                             # Python ones
    from multiprocessing.pool import Pool
except:
    print("pool4xi.py *** failed in from multiprocessing.pool import Pool ***")
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from ace_object4xi import ace_object4xi
from applyresult4xi import ApplyResult4Xi

from constant_pool4xi import ConstantPool4Xi

from cpu_corecount4xi import cpu_corecount4xi

from finalize4xi import Finalize4Xi

from imapiterator4xi import IMapIterator4Xi 
from imapunorderediterator4xi import IMapUnorderedIterator4Xi

from mapresult4xi import MapResult4Xi
from mapstar4xi import mapstar4xi

from print4xi import print4xi
from process4xi import Process4Xi

from queue4xi import Queue4Xi

from reason_object4xi import reason_object4xi

from sense_object4xi import sense_object4xi
from simplequeue4xi import SimpleQueue4Xi

from terminate4xi import terminate4xi
from time4xi import time4xi

#"
#/>


# =================================================================================================
#<class4xi class = "MaybeEncodingError4Xi" base = "object" child = "None" synopsis = "representing a process pool" usage = 
#"
#   pool.py
#       Pool
#           worker
#               try:
#                   put((job, i, result))
#               except Exception as e:
#                   wrapped = MaybeEncodingError(e, result[1])            
#"
#>
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# =================================================================================================
#
class MaybeEncodingError4Xi(Exception):
    '''
    Wraps possible unpickleable errors, so they can be
    safely sent through the socket.
    '''
    
    
    # ---------------------------------------------------------------------------------------------
    # Public API of this class
    # ---------------------------------------------------------------------------------------------    
    #<expose4xi expose = "
    _exposed_ = ('sense', 'reason', 'ace')          
    #"
    #/>    
        
    #                                        
    # ---------------------------------------------------------------------------------------------
    # sharable class variables
    # ---------------------------------------------------------------------------------------------      
    #<share4xi share = " 

    #"
    #/>
        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init-of-MaybeEncodingError4Xi" usage = "initializes MaybeEncodingError4Xi">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------                              
    def __init__(self, exc, value):
        '''
        initializes MaybeEncodingError4Xi    
        '''
            
        # -----------------------------------------------------------------------------------------
        # (Step 1/5)           
        # ----------------------------------------------------------------------------------------- 
             
        class2print = "MaybeEncodingError4Xi"
        method2print = "__init__"
        
        message2print = "{(Step 1/5a) started" + "; init-of-MaybeEncodingError4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
                        
        message2print = "{(Step 1/5b) borning" + "; pool2xi-of-MaybeEncodingError4Xi-borning: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
                     
        message2print = "{(Step 1/5c) inheriting" + "; Exception-inheriting-by-pool2xi-of-MaybeEncodingError4Xi: " + str(Exception)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        # 
                        
        message2print = "{(Step 1/5d) passed" + "; exc-passed-to-init-of-MaybeEncodingError4Xi: " + str(exc) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
                     
        message2print = "{(Step 1/5f) passed" + "; value-passed-to-init-of-MaybeEncodingError4Xi: " + str(value) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
                     
        # -----------------------------------------------------------------------------------------
        # (Step 2/5)           
        # ----------------------------------------------------------------------------------------- 
        message2print = "{(Step 2/5a) using" + "; exc-using-by-init-of-MaybeEncodingError4Xi: " + str(exc)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        #  
        try:
            self.exc = repr(exc)                                  
            
            message2print = "{(Step 2/5b) set" + "; exc-of-maybeencodingerror2xi-set-by-init-of-MaybeEncodingError4Xi to: " + str(self.exc ) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #
                         
        except:
            message2print = "{{(Step 2/5z) hit" + "; exc-hit-by-init-of-MaybeEncodingError4Xi: " + " *** " + str(exc)  + " *** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
                      
        # -----------------------------------------------------------------------------------------    
        # (Step 3/5)
        # -----------------------------------------------------------------------------------------     
        message2print = "{(Step 3/5a) using" + "; value-using-by-init-of-MaybeEncodingError4Xi: " + str(value)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        #  
        try:
            self.value = repr(value)        
            
            message2print = "{(Step 3/5b) set" + "; value-of-maybeencodingerror2xi-set-by-init-of-MaybeEncodingError4Xi to: " + str(self.value) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #  
        except:
            message2print = "{{(Step 3/5z) hit" + "; value-hit-by-init-of-MaybeEncodingError4Xi: " + " *** " + str(value)  + " *** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)          
    
        # -----------------------------------------------------------------------------------------    
        # (Step 4/5)
        # -----------------------------------------------------------------------------------------     
        message2print = "{(Step 4/5a) using" + "; value-using-by-init-of-MaybeEncodingError4Xi: " + str(value)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        # 
        try:
            super(MaybeEncodingError, self).__init__(self.exc, self.value)
            
            message2print = "{(Step 4/5b) used" + "; exc-of-maybeencodingerror2xi-used-by-init-of-MaybeEncodingError4Xi: " + str(self.exc)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)    
            #  
        except:
            message2print = "{{(Step 4/5z) hit" + "; value-hit-by-init-of-MaybeEncodingError4Xi: " + " *** " + str(value)  + " *** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                 
    
        # -----------------------------------------------------------------------------------------    
        # (Step 5/5)
        # -----------------------------------------------------------------------------------------     
        message2print = "{(Step 5/5) returning" + "; init-of-MaybeEncodingError4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
                                 
                 
                                      
    #</methodize4xi>
            
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "setup-queues-of-MaybeEncodingError4Xi" usage = "
    #   (self)
    #">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # --------------------------------------------------------------------------------------------- 
    def __str__(self):
        '''
        returns error    
        ''' 
    
        # -----------------------------------------------------------------------------------------    
        # (Step 1/2) 
        # -----------------------------------------------------------------------------------------     
        class2print = "MaybeEncodingError4Xi"
        method2print = "__str__"
        
        message2print = "{(Step 1/2) started" + "; str-of-MaybeEncodingError4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        #
        

        # -----------------------------------------------------------------------------------------    
        #(Step 2/2) 
        # -----------------------------------------------------------------------------------------                 
        message2print = "{(Step 2/2) returning" + "; str-of-MaybeEncodingError4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        #
        
        return "MaybeEncodingError4Xi *** Error sending result: '%s'. Reason: '%s'" % (self.value,
                                                             self.exc)                
                
    #</methodize4xi>
                
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "repr-of-MaybeEncodingError4Xi" usage = "
    #   (self)
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # --------------------------------------------------------------------------------------------- 
    def __repr__(self):
        '''
        repr
        '''
    
        # -----------------------------------------------------------------------------------------    
        # (Step 1/2)
        # -----------------------------------------------------------------------------------------     
             
        class2print = "MaybeEncodingError4Xi"
        method2print = "repr"
        
        message2print = "{(Step 1/2) started" + "; repr-of-MaybeEncodingError4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        #
        

        # -----------------------------------------------------------------------------------------    
        # (Step 2/2)
        # -----------------------------------------------------------------------------------------                 
        message2print = "{(Step 2/2) returning" + "; repr-of-MaybeEncodingError4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        #                         
                
        return "<MaybeEncodingError4Xi: %s>" % str(self)
    #</methodize4xi>
            

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "sense-of-MaybeEncodingError4Xi" usage = "senses MaybeEncodingError4Xi class objects">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def sense(self):
        '''
        senses MaybeEncodingError4Xi class objects
        '''
        
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
               
        class2print = 'MaybeEncodingError4Xi'
        method2print = 'sense'
        
        
        message2print = "{started" + "; sense-of-MaybeEncodingError4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        #PX: 
     
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------  
        message2print = "{sensing" + "; MaybeEncodingError4Xi-sensing-by-sense-of-MaybeEncodingError4Xi: " + str(MaybeEncodingError4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        #PX: 
                         
        
        # -----------------------------------------------------------------------------------------
        # get sensed knowledge for this object
        # -----------------------------------------------------------------------------------------        
        kb2xi = sense_object4xi(self)
        
        message2print = "{got" + "; kb2xi-got-by-sense-of-MaybeEncodingError4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #PX: 
                  
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # -----------------------------------------------------------------------------------------         
        try:
            kb2xi['taskqueue-of-pool2xi'] = self._taskqueue
            kb2xi['cache-of-pool2xi'] = self._cache             
            kb2xi['pool-of-pool2xi'] = self._pool
            kb2xi['task-handle-of-pool2xi'] = self._task_handle         
            kb2xi['task-handler-daemon-of-pool2xi'] = self._task_handler.daemon
            kb2xi['task-handler-state-of-pool2xi'] = self._task_handler._state             
            kb2xi['result-handler-of-pool2xi'] = self._result_handler
            kb2xi['result-handler-daemon-of-pool2xi'] = self._result_handler.daemon              
            kb2xi['result-handler-state-of-pool2xi'] = self._result_handler._state
            kb2xi['terminate-of-pool2xi'] = self._terminate             
            kb2xi['inqueue-of-pool2xi'] = self._inqueue
            kb2xi['outqueue-of-pool2xi'] = self._outqueue         
            kb2xi['quick-put-of-pool2xi'] = self._quick_put
            kb2xi['quick-get-of-pool2xi'] = self._quick_get             
            kb2xi['state-of-pool2xi'] = self._state
            kb2xi['Process-of-pool2xi'] = self.Process      
            kb2xi['Process-of-pool2xi'] = MaybeEncodingError4Xi.Process
        except:
            message2print = "{yielded" + "; kb2xi-yielded-by-sense-of-MaybeEncodingError4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            #PX: 
              
             
        message2print = "{sensed" + "; MaybeEncodingError4Xi-sensed-by-sense-of-MaybeEncodingError4Xi: " + str(MaybeEncodingError4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
        #PX: 
            #  {              'object': <pool4xi.MaybeEncodingError4Xi object at 0x02FA49F0>, 
            #   'taskqueue-of-pool2xi': <queue.Queue object at 0x02FBBB30>, 
            #        'pool-of-pool2xi': [<Process4Xi(PoolWorker4Xi-4, stopped daemon)>, <Process4Xi(PoolWorker4Xi-5, stopped daemon)>],
            #       'cache-of-pool2xi': {}}          
        # -----------------------------------------------------------------------------------------
        # 
        # -----------------------------------------------------------------------------------------         
        message2print = "{returning" + "; kb2xi-returning-by-sense-of-MaybeEncodingError4Xi: " + str(kb2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
        #PX: 
                                   
          
        return kb2xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
    #</methodize4xi>
    
        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "reason-of-MaybeEncodingError4Xi" usage = "reasons MaybeEncodingError4Xi class objects">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def reason(self):
        '''
        method reason: reasons MaybeEncodingError4Xi class objects
        '''
        
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
               
        class2print = 'MaybeEncodingError4Xi'
        method2print = 'reason'

        
        message2print = "{started" + "; reason-of-MaybeEncodingError4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        #PX: 
         
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        message2print = "{reasoning" + "; MaybeEncodingError4Xi-reasoning-by-reason-of-MaybeEncodingError4Xi: " + str(MaybeEncodingError4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        #PX: 
                  
        
        # -----------------------------------------------------------------------------------------
        # get reasoned knowledge for this object
        # -----------------------------------------------------------------------------------------         
        kb4xi = reason_object4xi(self)
        
        message2print = "{got" + "; kb4xi-got-by-reason-of-MaybeEncodingError4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #PX: 
                  
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb4xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------          
        
        
          
        
        message2print = "{reasoned" + "; MaybeEncodingError4Xi-reasoned-by-reason-of-MaybeEncodingError4Xi: " + str(MaybeEncodingError4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
        #PX: 
          
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        message2print = "{returning" + "; kb4xi-returning-by-reason-of-MaybeEncodingError4Xi: " + str(kb4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
        #PX: 
                                 
          
        return kb4xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
    
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "ace-of-MaybeEncodingError4Xi" usage = "aces MaybeEncodingError4Xi class objects">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def ace(self):
        '''
        method ace: aces MaybeEncodingError4Xi class objects 
        '''
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
               
        
        class2print = 'MaybeEncodingError4Xi'
        method2print = 'ace'
        
        
        message2print = "{started" + "; ace-of-MaybeEncodingError4Xi-started: "  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        #PX: 
                
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        message2print = "{acing" + "; MaybeEncodingError4Xi-acing-by-ace-of-MaybeEncodingError4Xi: " + str(MaybeEncodingError4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        #PX: 
                       
        
        # -----------------------------------------------------------------------------------------
        # get aced knowledge for this object
        # -----------------------------------------------------------------------------------------        
        kb8xi = ace_object4xi(self)  
        
        message2print = "{got" + "; kb8xi-got-by-ace-of-MaybeEncodingError4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #PX: 
                  


        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb8xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------              
        
          
        message2print = "{aced" + "; MaybeEncodingError4Xi-aced-by-ace-of-MaybeEncodingError4Xi: " + str(MaybeEncodingError4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                   
        #PX: 
          
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        message2print = "{returning" + "; kb8xi-returning-by-ace-of-MaybeEncodingError4Xi: " + str(kb8xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
        #PX: 
                                    
        
        return kb8xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
#</class4xi>
#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_pool1_mp_xi4.txt
#   sense-pool-one-4xi.xml
#   reason-pool-one-4xi.xml
#   ace-pool-one-4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 
#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of pool4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
